NX二次開發(fā)習(xí)題及源碼_第1頁
NX二次開發(fā)習(xí)題及源碼_第2頁
NX二次開發(fā)習(xí)題及源碼_第3頁
NX二次開發(fā)習(xí)題及源碼_第4頁
NX二次開發(fā)習(xí)題及源碼_第5頁
已閱讀5頁,還剩53頁未讀, 繼續(xù)免費閱讀

下載本文檔

版權(quán)說明:本文檔由用戶提供并上傳,收益歸屬內(nèi)容提供方,若內(nèi)容存在侵權(quán),請進行舉報或認(rèn)領(lǐng)

文檔簡介

1、淺溪水整理1、創(chuàng)建NXhello界面代碼:#include <uf_ui.h>/包含UF_initialize()和UF_terminate()函數(shù)原型的頭文件#include <uf.h>/包含uc1601()函數(shù)原型的頭文件extern void ufusr(char *param, int *retcode, int param_len) if (UF_initialize()!=0)/獲取NX openapi的執(zhí)行權(quán)限 return;uc1601("Hello NX",1);/彈出消息窗口,顯示“Hello NX”UF_terminate()

2、;/釋放NX OPEN API的執(zhí)行權(quán)限 運行結(jié)果截圖:2、創(chuàng)建一個模型,并在信息窗口顯示模型的tag值。代碼:#include <stdio.h>#include <uf.h>#include <uf_modl.h>#include < uf_ui_ugopen.h>#include <uf_part.h>#include <uf_ui.h>static void do_ugopen_api(void) typedef unsigned int tag_t;UF_FEATURE_SIGN sign = UF_NULLSI

3、GN;/無布爾運算double cyl_orig3 = 0,0,0;/圓柱的圓心坐標(biāo)char *cyl_height="100"char *cyl_diam="40"double direction3=0,0,1;/延Z軸正方向tag_t obj=NULL_TAG;UF_MODL_create_cyl1(sign, cyl_orig,cyl_height,cyl_diam,direction, &obj);UF_UI_open_listing_window(); /顯示信息框:tag/*Returns the tag of the current

4、 display part. In a non-assembly part, this is the same as the work part. If there currently isn't a displayed part, a NULL_TAG is returned. */obj=UF_PART_ask_display_part();if(obj = NULL_TAG) /沒有部件的時候顯示的信息提示框 uc1601 ( "當(dāng)前沒有任何文件可供操作!",1); else char s10;sprintf(s, "%d",obj); /

5、sprinf()功能:把格式化的數(shù)據(jù)寫入某個字符串UF_UI_write_listing_window(s);return;extern void ufusr( char *param, int *retcode, int rlen )/提供入口點if(UF_initialize()!=0)return;do_ugopen_api ();UF_terminate();return;extern int ufusr_ask_unload(void)return(UF_UNLOAD_IMMEDIATELY);運行結(jié)果截圖:(1)無部件時的輸出(2)有部件時的輸出結(jié)果3、open part 用戶入口

6、實例創(chuàng)建open part user exit在用戶點擊“open”時創(chuàng)建新部件,在其中創(chuàng)建sphere詳細(xì)說明user exit設(shè)置文件過程代碼如下:#include < uf_assem.h>#include <uf_part.h>#include <uf_ui_ugopen.h>#include <stdio.h>#include <uf.h>#include <uf_modl.h>#include <uf_ui.h>#define UF_CALL(X) (report( _FILE_, _LINE_,

7、#X, (X)static int report( char *file, int line, char *call, int irc)if (irc)char messg133;printf("%s, line %d: %sn", file, line, call);(UF_get_fail_message(irc, messg) ?printf(" returned a %dn", irc) :printf(" returned error %d: %sn", irc, messg);return(irc);static void

8、 do_ugopen_api(void)UF_FEATURE_SIGN sign = UF_NULLSIGN;tag_t part=null_tag;/如果沒有賦值的話,直接就是"tag_t part",當(dāng)你執(zhí)行.dll文件時,就直接跑到建模環(huán)境了,沒有信息提示框。當(dāng)然你可以多申明幾個tag_tchar part_name13 = "F:long.prt"/設(shè)置part名字以及存儲路徑double center 3 =0,0,0;/球心坐標(biāo)char * diam="100"int units =1; uc1601("創(chuàng)建直徑

9、為100的球",1);UF_PART_new (part_name, units, &part);/在當(dāng)前的會話框中創(chuàng)建新的part,并把其作為工作部件/試比較下面兩個函數(shù)UF_MODL_create_sphere(sign,part,center,diam, &part );/UF_MODL_create_sphere1(sign,center,diam, &part);extern void ufusr(char *param, int *retcode, int paramLen) if (!UF_CALL(UF_initialize() do_ugop

10、en_api();UF_CALL(UF_terminate(); extern int ufusr_ask_unload(void)return (UF_UNLOAD_IMMEDIATELY);運行結(jié)果截圖:4、創(chuàng)建一個block,并指定某一特定面高亮顯示。代碼如下圖:#include <stdio.h>#include <uf.h>#include <uf_modl.h>#include<uf_part.h>#include<uf_ui.h>#include<uf_obj.h>#include<uf_disp.h&

11、gt;#define UF_CALL(X) (report( _FILE_, _LINE_, #X, (X)static int report( char *file, int line, char *call, int irc)if (irc)char messg133;printf("%s, line %d: %sn", file, line, call);(UF_get_fail_message(irc, messg) ?printf(" returned a %dn", irc) :printf(" returned error %d:

12、 %sn", irc, messg);return(irc);static void do_ugopen_api(void)UF_FEATURE_SIGN sign=UF_NULLSIGN; tag_t obj=null_tag;double center 3=0,0,0 ; char *edge_len3="10","10","10"tag_t blk_feat;int units=2;/此行代碼的賦值,經(jīng)過調(diào)試,貌似只有1和2可以,它們的區(qū)別就是生成模型的默認(rèn)大小不同,可以自己調(diào)調(diào)看。char part_name13=&

13、quot;F:long.part"/此段代碼有點小重要,注意一定要保證完整性,不完整的話,估計會出現(xiàn)好多問題,繞好多路。uc1601("創(chuàng)建一個正方體,并指定下表面高亮顯示",1);UF_PART_new(part_name,units,&obj);/UF_MODL_create_block(sign,obj,center,edge_len,&blk_feat);UF_MODL_create_block1(sign,center,edge_len,&blk_feat);uf_list_p_t face_list;/鏈表UF_MODL_cre

14、ate_list(&face_list);/創(chuàng)建鏈表UF_MODL_ask_feat_faces(blk_feat,&face_list);/獲取實體的個表面特征,并放入鏈表中int count=0;UF_MODL_ask_list_count(face_list,&count);for(int i=0;i<count;i+)UF_MODL_ask_list_item(face_list,i,&obj);/從鏈表中取出對象int type;double point 20 ; double dir 20 ;double box 6;double radius

15、;double rad_data; int norm_dir;UF_MODL_ask_face_data(obj,&type,point,dir,box,&radius,&rad_data,&norm_dir);/這個函數(shù)非常重要,可以說是本段代碼中最核心的部分。if(dir0=0&&dir1=0&&dir2=-1)/確定高亮顯示的那個面的法向量UF_DISP_set_highlight(obj,1);/UF_OBJ_set_color(obj, 186);break;/*ARGSUSED*/extern void ufusr(c

16、har *param, int *retcode, int paramLen)if (!UF_CALL(UF_initialize()do_ugopen_api();UF_CALL(UF_terminate();extern int ufusr_ask_unload(void)return (UF_UNLOAD_IMMEDIATELY);運行結(jié)果截圖:注:和高亮顯示還有一個類似的設(shè)置,就是給實體上色,所用到的函數(shù)是:UF_OBJ_set_color(obj, 186);上面的這個函數(shù)是把對象顯示成紅色,如下圖:“186”是紅色的代號。這些數(shù)字可以在UG交互模式下的對象顯示里查到,如下圖:5、用

17、遍歷的形式輸出當(dāng)前part所有面的tag至listing window代碼如下:#include < uf_assem.h>#include <uf_part.h>#include <uf_ui_ugopen.h>#include <stdio.h>#include <uf.h>#include <uf_ui.h>#include <uf_modl.h>#include <uf_obj.h>#define UF_CALL(X) (report( _FILE_, _LINE_, #X, (X)stat

18、ic int report( char *file, int line, char *call, int irc)if (irc)char messg133;printf("%s, line %d: %sn", file, line, call);(UF_get_fail_message(irc, messg) ?printf(" returned a %dn", irc) :printf("returned error %d: %sn", irc, messg);return(irc);static void do_ugopen_a

19、pi(void)UF_FEATURE_SIGN sign = UF_NULLSIGN;double center 3 = 0,0,0; char * edge_len 3 ="100","100","100" tag_t blk_feat =null_tag;char * part_name="F:long"int units=1;tag_t part =NULL_TAG;uc1601("創(chuàng)建一個block,并顯示每個面的tag",1);UF_PART_new(part_name,units,&

20、amp;part);/在當(dāng)前會話窗口中創(chuàng)建一個part,并使其成為工作部件UF_CALL(UF_MODL_create_block1(sign,center,edge_len, &blk_feat);if(blk_feat = NULL_TAG) uc1601 ( "當(dāng)前沒有任何文件可供操作!",1); elseint type=70;int subtype=2;tag_t obj=null_tag;tag_t display_part=UF_PART_ask_display_part();UF_OBJ_cycle_objs_in_part(display_part

21、,70,&obj);while(obj!=null_tag)UF_OBJ_ask_type_and_subtype(obj,&type,&subtype);/返回一個被標(biāo)記的對象的對象類型和子類型UF_OBJ_cycle_objs_in_part (display_part,UF_solid_type,&obj);/查詢遍歷對象if(subtype= UF_solid_face_subtype)char s50;sprintf(s, "%d", obj);UF_CALL(UF_UI_open_listing_window();UF_CALL(

22、UF_UI_write_listing_window(s);UF_CALL(UF_UI_write_listing_window("n");void ufusr(char *param, int *retcode, int paramLen)if (!UF_CALL(UF_initialize()do_ugopen_api();UF_CALL(UF_terminate();int ufusr_ask_unload(void)return (UF_UNLOAD_IMMEDIATELY);運行結(jié)果截屏:6、遍歷當(dāng)前part中所有features,輸出其類型至listing wi

23、ndow,UF_MODL_ask_feat_type()代碼如下:#include <uf.h>#include <stdio.h>#include <uf_obj.h>#include <uf_part.h>#include <uf_ui.h>#include <uf_modl.h>#define UF_CALL(X) (report( _FILE_, _LINE_, #X, (X)static int report( char *file, int line, char *call, int irc)if (irc)c

24、har messg133;printf("%s, line %d: %sn", file, line, call);(UF_get_fail_message(irc, messg) ?printf(" returned a %dn", irc) :printf(" returned error %d: %sn", irc, messg);return(irc);static void do_ugopen_api(void)char * part_name="F:NX"UF_FEATURE_SIGN sign = U

25、F_NULLSIGN;tag_t part=null_tag;double center 3 =0,0,0;char * diam="100"int units =1; uc1601("創(chuàng)建直徑為100的球,并顯示其實體特征。",1);UF_PART_new (part_name, units, &part);/在當(dāng)前的會話框中創(chuàng)建新的part,并把其作為工作部件UF_MODL_create_sphere1(sign,center,diam, &part);int count = 0;char* solid_feature;tag_t f

26、ound = NULL_TAG;tag_t display_part = UF_PART_ask_display_part();UF_UI_open_listing_window();UF_OBJ_cycle_objs_in_part(display_part,UF_feature_type,&found); while( found != NULL_TAG )count+;UF_CALL(UF_MODL_ask_feat_type(found,&solid_feature);/獲取輸入的特征的類型UF_CALL(UF_UI_write_listing_window("

27、;feature:");UF_CALL(UF_UI_write_listing_window(solid_feature);UF_CALL(UF_UI_write_listing_window("n");UF_CALL(UF_OBJ_cycle_objs_in_part(display_part,UF_feature_type,&found);extern void ufusr(char *param, int *retcode, int paramLen)if (!UF_CALL(UF_initialize()do_ugopen_api();UF_CAL

28、L(UF_terminate();extern int ufusr_ask_unload(void)return(UF_UNLOAD_IMMEDIATELY);運行結(jié)果截屏:6、創(chuàng)建人機交互界面新建圓柱體,并可以隨意選擇原點和矢量方向。代碼如下:#include <uf.h>#include <stdio.h> #include <uf_defs.h>#include <uf_exit.h>#include <uf_styler.h>#include <uf_mb.h> #include <uf_disp.h>

29、#include <uf_part.h>#include <uf_ui.h>#include <uf_modl.h>#include <uf_obj.h>#include "cylinder.h"#define CHANGE_CB_COUNT ( 3 + 1 ) /* Add 1 for the terminator */ tag_t blk_tag= null_tag;double blk_orig = 0,0,0; double direction 3 ;char * part_name="F:long"

30、;int units=1;static UF_STYLER_callback_info_t CHANGE_cbsCHANGE_CB_COUNT = UF_STYLER_DIALOG_INDEX, UF_STYLER_APPLY_CB , 0, CHANGE_apply_cb, CHANGE_ACTION_2 , UF_STYLER_ACTIVATE_CB , 1, CHANGE_action_2_act_cb, CHANGE_ACTION_3 , UF_STYLER_ACTIVATE_CB , 1, CHANGE_action_3_act_cb, UF_STYLER_NULL_OBJECT,

31、UF_STYLER_NO_CB, 0, 0 ;static UF_MB_styler_actions_t actions = "cylinder.dlg", NULL, CHANGE_cbs, UF_MB_STYLER_IS_NOT_TOP , NULL, NULL, NULL, 0 /* This is a NULL terminated list */;static int init_proc(UF_UI_selection_p_t select,void *user_data);extern void ufusr (char *param, int *retcode,

32、 int rlen)uc1601("創(chuàng)建一個圓柱,并指明原點和矢量",1); UF_PART_new(part_name,units,&blk_tag); int response = 0; int error_code = 0; if ( ( UF_initialize() ) != 0 ) return; if ( ( error_code = UF_STYLER_create_dialog ( "cylinder.dlg", CHANGE_cbs, /* Callbacks from dialog */ CHANGE_CB_COUNT, /

33、* number of callbacks*/ NULL, /* This is your client data */ &response ) ) != 0 ) char fail_message133; /* Get the user function fail message based on the fail code.*/ UF_get_fail_message(error_code, fail_message); UF_UI_set_status (fail_message); printf ( "%sn", fail_message ); UF_ter

34、minate(); return;extern int ufusr_ask_unload (void) return ( UF_UNLOAD_IMMEDIATELY );extern void ufusr_cleanup (void) return;int CHANGE_apply_cb ( int dialog_id,void * client_data,UF_STYLER_item_value_type_p_t callback_data) if ( UF_initialize() != 0) return ( UF_UI_CB_CONTINUE_DIALOG ); /直徑的相關(guān)參數(shù) UF

35、_STYLER_item_value_type_t data; data.item_id = "REAL_0" data.item_attr = UF_STYLER_VALUE; data.indicator = UF_STYLER_REAL_VALUE; UF_STYLER_ask_value(dialog_id,&data);/用來查詢對話框控件的屬性值。 char diameter133; sprintf(diameter,"%f",data.value.real); /高度的相關(guān)參數(shù) data.item_id = "REAL_1

36、" data.item_attr = UF_STYLER_VALUE; data.indicator = UF_STYLER_REAL_VALUE; UF_STYLER_ask_value(dialog_id,&data); char height133; sprintf(height,"%f",data.value.real); UF_FEATURE_SIGN sign = UF_NULLSIGN; /tag_t blk_tag= null_tag; /UF_PART_new(part_name,units,&blk_tag); UF_MODL_

37、create_cyl1(sign,blk_orig,diameter,height,direction , &blk_tag); UF_STYLER_free_value(&data);/釋放字符串或數(shù)組申請的內(nèi)存 UF_STYLER_ask_value(dialog_id,&data); UF_MODL_update(); UF_STYLER_free_value(&data); UF_terminate (); return (UF_UI_CB_CONTINUE_DIALOG); /選擇圓柱中心點,選用點構(gòu)造器UF_UI_point_construct()i

38、nt CHANGE_action_2_act_cb ( int dialog_id,void * client_data,UF_STYLER_item_value_type_p_t callback_data) if ( UF_initialize() != 0) return ( UF_UI_CB_CONTINUE_DIALOG ); char *cue = "點構(gòu)造器" UF_UI_POINT_base_method_t method = UF_UI_POINT_INFERRED; tag_t point_tag = NULL_TAG; /double sBasePoi

39、nt3; int response; int error = UF_UI_point_construct(cue, &method, &point_tag, blk_orig, &response); UF_terminate (); return (UF_UI_CB_CONTINUE_DIALOG); /選擇圓柱方向(拾取向量對話框)int CHANGE_action_3_act_cb ( int dialog_id,void * client_data,UF_STYLER_item_value_type_p_t callback_data) if ( UF_init

40、ialize() != 0) return ( UF_UI_CB_CONTINUE_DIALOG ); double vec3, pnt3; int mode = UF_UI_ZC_AXIS;/默認(rèn)矢量方向 int disp_flag = UF_UI_DISP_NO_VECTOR;/顯示臨時坐標(biāo),是比較UF_UI_DISP_NO_VECTOR int response = 0; int ifail; UF_initialize(); ifail = UF_UI_specify_vector( "選擇一個矢量", &mode, disp_flag, vec, pnt,

41、 &response ); if ( ifail != 0 | response != UF_UI_OK ) printf( "No vector selected n" ); else printf( "Vect base (%f, %f, %f), direction (%f, %f, %f) n", pnt0, pnt1, pnt2, vec0, vec1, vec2 ); fflush( stdout ); UF_terminate (); /double direction3; for(int i=0;i<3;i+) direct

42、ioni=veci-pnti; /* Callback acknowledged, do not terminate dialog */ return (UF_UI_CB_CONTINUE_DIALOG); static int init_proc(UF_UI_selection_p_t select,void* user_data) /指明了mask_triple數(shù)組的長度int num_triples = 1;UF_UI_mask_t mask_triples = UF_solid_type, 0, UF_UI_SEL_FEATURE_SOLID_BODY;if(UF_UI_set_sel

43、_mask(select, UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC, num_triples, mask_triples) = 0)return (UF_UI_SEL_SUCCESS);elsereturn (UF_UI_SEL_FAILURE);運行結(jié)果截屏7、(1)新建一個對象,選擇對象的面,返回這個面的tag值。代碼如下:#include <stdio.h>#include <uf.h>#include <uf_ui.h>#include <uf_ui_types.h>#include <uf

44、_disp.h>static int sel_init_proc(UF_UI_selection_p_t select,void *user_data);#define UF_CALL(X) (report( _FILE_, _LINE_, #X, (X)static int report( char *file, int line, char *call, int irc) if (irc) char messg133; printf("%s, line %d: %sn", file, line, call); (UF_get_fail_message(irc, m

45、essg) ? printf(" returned a %dn", irc) : printf(" returned error %d: %sn", irc, messg); return(irc);static void do_ugopen_api(void)/類選擇對話框相關(guān)變量 char cue = "Select Objects" char title = "Select faces" int scope=UF_UI_SEL_SCOPE_NO_CHANGE;int response, count, i; t

46、ag_p_t objects;int error_code = 0;char* str = (char*)UF_allocate_memory(sizeof(unsigned int)+1,&error_code); UF_UI_open_listing_window();if(UF_CALL(UF_UI_select_with_class_dialog( cue, title, scope,sel_init_proc, NULL, &response, &count, &objects) = 0) printf("object count = %dn

47、",count); if (response = UF_UI_OK && count > 0) for (i=0; i<count; i+) sprintf(str,"%dn",objectsi); UF_UI_write_listing_window(str); UF_DISP_set_highlight(objectsi, 0);/把選中的對象高亮顯示 UF_free(objects); /* selection initialization procedure */static int sel_init_proc(UF_UI_se

48、lection_p_t select,void* user_data) int num_triples=1; UF_UI_mask_t mask_triples = UF_solid_type, 0, UF_UI_SEL_FEATURE_PLANAR_FACE; /* enable only lines and edges */ if(UF_CALL(UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC, num_triples, mask_triples) = 0) return (UF_UI_SEL_SUCCE

49、SS); else return (UF_UI_SEL_FAILURE); /*ARGSUSED*/void ufusr(char *param, int *retcode, int param_len) if (!UF_CALL(UF_initialize() do_ugopen_api(); UF_CALL(UF_terminate(); int ufusr_ask_unload(void) return (UF_UNLOAD_IMMEDIATELY);運行結(jié)果截屏:(2)讀取文本文件里的內(nèi)容和往文本文件中寫入信息。代碼如下:#include <stdio.h> #includ

50、e <uf.h>#include <uf_defs.h>#include <uf_exit.h>#include <uf_ui.h>#include <uf_styler.h>#include <uf_mb.h> #include <uf_modl.h>#include <uf_disp.h>#include <uf_obj.h>#include <fstream>#include "Multiple_text.h"using namespace std;

51、#define CHANGE_CB_COUNT ( 3 + 1 ) /* Add 1 for the terminator */char prompt_string133="請選取文本文件"char title_string133="選取文本文件"char filter_string133 = "文本文件"char default_name133=" "char filename133;int response=0;static UF_STYLER_callback_info_t CHANGE_cbsCHANGE_

52、CB_COUNT = UF_STYLER_DIALOG_INDEX, UF_STYLER_APPLY_CB , 0, CHANGE_apply_cb, CHANGE_ACTION_1 , UF_STYLER_ACTIVATE_CB , 1, CHANGE_action_1_act_cb, CHANGE_ACTION_2 , UF_STYLER_ACTIVATE_CB , 1, CHANGE_action_2_act_cb, UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 ;static UF_MB_styler_actions_t actions = "Multiple_text.dlg", NULL, CHANGE_cbs, UF_MB_STYLER_IS_NOT_TOP , NULL, NULL, NULL, 0 /*

溫馨提示

  • 1. 本站所有資源如無特殊說明,都需要本地電腦安裝OFFICE2007和PDF閱讀器。圖紙軟件為CAD,CAXA,PROE,UG,SolidWorks等.壓縮文件請下載最新的WinRAR軟件解壓。
  • 2. 本站的文檔不包含任何第三方提供的附件圖紙等,如果需要附件,請聯(lián)系上傳者。文件的所有權(quán)益歸上傳用戶所有。
  • 3. 本站RAR壓縮包中若帶圖紙,網(wǎng)頁內(nèi)容里面會有圖紙預(yù)覽,若沒有圖紙預(yù)覽就沒有圖紙。
  • 4. 未經(jīng)權(quán)益所有人同意不得將文件中的內(nèi)容挪作商業(yè)或盈利用途。
  • 5. 人人文庫網(wǎng)僅提供信息存儲空間,僅對用戶上傳內(nèi)容的表現(xiàn)方式做保護處理,對用戶上傳分享的文檔內(nèi)容本身不做任何修改或編輯,并不能對任何下載內(nèi)容負(fù)責(zé)。
  • 6. 下載文件中如有侵權(quán)或不適當(dāng)內(nèi)容,請與我們聯(lián)系,我們立即糾正。
  • 7. 本站不保證下載資源的準(zhǔn)確性、安全性和完整性, 同時也不承擔(dān)用戶因使用這些下載資源對自己和他人造成任何形式的傷害或損失。

評論

0/150

提交評論